// Copyright 2000 by Robert Dick.
// All rights reserved.

#ifndef R_ALGO_H_
#define R_ALGO_H_

/*###########################################################################*/
#include <algorithm>
#include <functional>
#include <iterator>
#include "RPair.h"
class ostream;

/*###########################################################################*/
template <typename InputIterator>
  void print(InputIterator first, InputIterator last, ostream &os,
  const char *sep = " ", const char *term = "\n");

template <typename Container>
  void print(const Container &c, ostream &os, const char *sep = " ",
  const char *term = "\n")
  {print(c.begin(), c.end(), os, sep, term);}

/*===========================================================================*/
// Puts indexes of elements in [begin, end), in increasing order, to dest.

template <typename InputIterator, typename OutputIterator>
  OutputIterator pri_map(InputIterator begin, const InputIterator end,
  OutputIterator dest);

template <class OutputIterator, class RandomNumberGenerator>
OutputIterator random_order(unsigned long first, unsigned long last,
unsigned long range, OutputIterator out, RandomNumberGenerator& rand);

/*###########################################################################*/
#include "RAlgo.cct"
#endif



